/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Produk;
import com.portofolio.entity.vo.ProdukId;

@Lazy
@Repository("produkDao")
public interface ProdukDao extends CrudRepository<Produk, ProdukId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaProduk like %:namaProduk% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaProduk") String namaProduk, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdProduk = :kdProduk")
	Map<String, Object> findByKdProduk(@Param("kdProfile") Integer kdProfile,@Param("kdProduk") Integer kdProduk, @Param("statusEnabled") boolean statusEnabled);

	String QListAll = "select new map(model.id.kdProduk as kdProduk,model.id.kdProfile as kdProfile "
			+ ", model.namaProduk as namaProduk " + ", model.reportDisplay as reportDisplay "
			+ ", model.kdJenisProduk as kdJenisProduk "
			+ ", model.harga as harga "
			+ ", jenisProduk.namaJenisProduk as namaJenisProduk " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal  "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec,model.version as version )"
			+ " from Produk model left join model.id id " + " left join model.jenisProduk jenisProduk "
			+ "  where id.kdProfile=:kdProfile and model.statusEnabled =:statusEnabled ";

}
